//+------------------------------------------------------------------+
//|                                                        $LR_M.mq4 |
//+------------------------------------------------------------------+
#property copyright "Vladimir"
#property link      "R"
//----
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_width1 1
//---- input parameters
extern int RegPeriod = 21;
//---- buffers
double LR_M[];
double LWMA[];
double MA[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(3);
   SetIndexBuffer(1, LWMA);
   SetIndexBuffer(2, MA);
//---- indicator lines
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, LR_M);
//----
   if(RegPeriod <= 0)
       RegPeriod = 21;
//----
   SetIndexDrawBegin(0, RegPeriod);
  
//---- name for DataWindow and indicator subwindow label
   short_name="$LR_M(" + RegPeriod + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Commodity Channel Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i, k, counted_bars = IndicatorCounted();
   if(RegPeriod <= 1)
       return(0);
   if(Bars <= RegPeriod) 
       return(0);
//---- initial zero
   if(counted_bars < 1)
     {
       for(i = 1; i <= RegPeriod; i++) 
           LWMA[Bars-i] = 0.0;
       for(i = 1; i <= RegPeriod; i++) 
           MA[Bars-i] = 0.0;
       for(i = 1; i <= RegPeriod; i++) 
           LR_M[Bars-i] =0.0;
     }
//---- last counted bar will be recounted
   int limit = Bars - counted_bars;
   if(counted_bars > 0) 
       limit++;
//---- moving average
   for(i = 0; i < limit; i++)
       LWMA[i] = iMA(NULL, 0, RegPeriod, 0, MODE_LWMA, PRICE_CLOSE, i);
   for(i = 0; i < limit; i++)
       MA[i] = iMA(NULL, 0, RegPeriod, 0, MODE_SMA, PRICE_CLOSE, i);

   i = Bars - RegPeriod + 1;
   if(counted_bars > RegPeriod - 1) 
       i = Bars - counted_bars - 1;
   while(i >= 0)
     {
     LR_M[i] = 3*LWMA[i]- 2*MA[i];
     i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+